#if defined(__linux__)
#if defined(__microblaze__)

/*
 * Use Linux system call.
 */

#define SYS_exit          1
#define SYS_fork          2
#define SYS_wait4       114
#define SYS_kill         37
#define SYS_execve       11

#define SYS_read          3
#define SYS_write         4
#define SYS_open          5
#define SYS_close         6

#define SYS_dup          41
#define SYS_pipe         42
#define SYS_dup2         63
#define SYS_pipe2       343

#define SYS_sigaction    67 /* rt_sigaction is 174 */
#define SYS_sigprocmask 126 /* rt_sigprocmask is 175 */

#define SYS_getpid       20
#define SYS_getppid      64
#define SYS_getsid      147
#define SYS_setsid       66
#define SYS_getpgid     132
#define SYS_setpgid      57
#define SYS_getpgrp      65

#define SYS_chdir        12
#define SYS_ioctl        54
#define SYS_brk          45
#define SYS_getdents    141
#define SYS_getcwd      183

	.section .text

	.globl	___exit
	.type	___exit, @function
___exit:
	addik	r12, r0, SYS_exit
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__fork
	.type	__fork, @function
__fork:
	addik	r12, r0, SYS_fork
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__wait4
	.type	__wait4, @function
__wait4:
	addik	r12, r0, SYS_wait4
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__kill
	.type	__kill, @function
__kill:
	addik	r12, r0, SYS_kill
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__execve
	.type	__execve, @function
__execve:
	addik	r12, r0, SYS_execve
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__read
	.type	__read, @function
__read:
	addik	r12, r0, SYS_read
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__write
	.type	__write, @function
__write:
	addik	r12, r0, SYS_write
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__open
	.type	__open, @function
__open:
	addik	r12, r0, SYS_open
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__close
	.type	__close, @function
__close:
	addik	r12, r0, SYS_close
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__dup
	.type	__dup, @function
__dup:
	addik	r12, r0, SYS_dup
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__pipe
	.type	__pipe, @function
__pipe:
	addik	r12, r0, SYS_pipe
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__dup2
	.type	__dup2, @function
__dup2:
	addik	r12, r0, SYS_dup2
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__pipe2
	.type	__pipe2, @function
__pipe2:
	addik	r12, r0, SYS_pipe2
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__sigaction
	.type	__sigaction, @function
__sigaction:
	addik	r12, r0, SYS_sigaction
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__sigprocmask
	.type	__sigprocmask, @function
__sigprocmask:
	addik	r12, r0, SYS_sigprocmask
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__getpid
	.type	__getpid, @function
__getpid:
	addik	r12, r0, SYS_getpid
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__getppid
	.type	__getppid, @function
__getppid:
	addik	r12, r0, SYS_getppid
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__getsid
	.type	__getsid, @function
__getsid:
	addik	r12, r0, SYS_getsid
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__setsid
	.type	__setsid, @function
__setsid:
	addik	r12, r0, SYS_setsid
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__getpgid
	.type	__getpgid, @function
__getpgid:
	addik	r12, r0, SYS_getpgid
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__setpgid
	.type	__setpgid, @function
__setpgid:
	addik	r12, r0, SYS_setpgid
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__getpgrp
	.type	__getpgrp, @function
__getpgrp:
	addik	r12, r0, SYS_getpgrp
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__chdir
	.type	__chdir, @function
__chdir:
	addik	r12, r0, SYS_chdir
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__ioctl
	.type	__ioctl, @function
__ioctl:
	addik	r12, r0, SYS_ioctl
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__brk
	.type	__brk, @function
__brk:
	addik	r12, r0, SYS_brk
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	__getdents
	.type	__getdents, @function
__getdents:
	addik	r12, r0, SYS_getdents
	brki	r14, 8
	rtsd	r15, 8
	nop

	.globl	____getcwd
	.type	____getcwd, @function
____getcwd:
	addik	r12, r0, SYS_getcwd
	brki	r14, 8
	rtsd	r15, 8
	nop
#endif
#endif
